# for debugging (super slow)
.global syscall_logc
syscall_logc:
        movq    $0, %rax
        jmp     system_call


.global syscall_container_alloc
syscall_container_alloc:
        movq    $1, %rax
        jmp     system_call


.global syscall_container_free
syscall_container_free:
        movq    $2, %rax
        jmp     system_call

.global syscall_quanta_alloc
syscall_quanta_alloc:
        movq    $3, %rax
        jmp     system_call

.global syscall_quanta_yield
syscall_quanta_yield:
        movq    $4, %rax
        jmp     system_call

.global syscall_frame_alloc
syscall_frame_alloc:
        movq    $5, %rax
        jmp     system_call

.global syscall_map
syscall_map:
        movq    $6, %rax
        jmp     system_call


system_call:
        # callee saved
        pushq   %rbx
        pushq   %rbp
        pushq   %r12
        pushq   %r13
        pushq   %r14
        pushq   %r15

        movq    %rcx, %r10 # we do not allow nested functions (GCC uses this register for them)

        syscall

        # callee restored
        popq    %r15
        popq    %r14
        popq    %r13
        popq    %r12
        popq    %rbp
        popq    %rbx

        retq
